<?xml version="1.0" encoding="UTF-8"?>
<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:seaf="http://seaf.sf.net/seaf"
	xmlns:svc="http://seaf.sf.net/seaf-service"
	xmlns:per="http://seaf.sf.net/seaf-persistence"
	version="2.0">
<import href="functions/SeafServiceTemplates.xsl" />
<import href="generator/seaf-persistence/functions/SeafPersistenceBusinessFunctions.xsl" />
<output method="text" />

<param name="persistence-merged-file-name" />
<param name="service-merged-file-name" />
<variable name="merged-persistence-file" select="document($persistence-merged-file-name)" />
<variable name="merged-service-file" select="document($service-merged-file-name)" />
<variable name="objects" select="$merged-service-file//svc:service-layer//svc:object" />

<template match="//svc:service-layer/svc:service/svc:controller">
	<variable name="full-type" select="svc:controller-interface-full-type(.,..)" />
	<variable name="class" select="seaf:type-class($full-type)" />
	<variable name="dir" select="seaf:type-dir($full-type)" />
	<variable name="package" select="seaf:type-package($full-type)" />

<result-document href="{$dir}/{$class}.java">

<text />/**
 * GENERATED BY Seaf Persistence Generator. DO NOT EDIT.
 */
package <value-of select="$package" />;

/**
 * <value-of select="..//@interface" /> controller interface for entity <text />
 	<value-of select="@entity" />.
 */
public interface <value-of select="$class" />
		extends net.sf.seaf.service.ServiceController {<text />

<for-each select="svc:operation">
	<variable name="request">
		<choose>
		<when test="svc:request-void" />
		<otherwise>
			<variable name="request-object" 
				select="svc:ref-service-object(svc:request-object,$objects)" />
			<variable name="request-type">
				<choose>
				<when test="svc:request-object/@pass-as='service-object'">
					<value-of select="svc:ref-service-object-full-type(
						svc:request-object,$objects)" />
				</when>
				<when test="$request-object/@processing-type='criteria-based'">
					<value-of select="per:entity-criteria-ref-full-type(
						svc:request-object/@entity,$merged-persistence-file)" />
				</when>
				<otherwise>
					<value-of select="per:entity-ref-full-type(
						svc:request-object/@entity,$merged-persistence-file)" />
				</otherwise>
				</choose>
			</variable>
			<text>
			</text>
			<value-of select="$request-type" />
			<text> </text>
			<value-of select="seaf:first-lower(seaf:type-class($request-type))" />
		</otherwise>
		</choose>
	</variable>
	<variable name="response">
		<choose>
		<when test="svc:response-void">void</when>
		<when test="svc:response-sequence[@paged='true']">
			<text>net.sf.seaf.service.PagedControllerResult</text>
		</when>
		<otherwise>
			<variable name="entity-full-type" select="per:entity-ref-full-type(
				svc:response-object/@entity|svc:response-sequence/@entity,
				$merged-persistence-file)" />
			<if test="svc:response-sequence">java.util.List&lt;</if>
			<value-of select="$entity-full-type" />
			<if test="svc:response-sequence">></if>
		</otherwise>
		</choose>
	</variable>
	<variable name="method-name">
		<choose>
		<when test="@method"><value-of select="@method" /></when>
		<otherwise><value-of select="@name" /></otherwise>
		</choose>
	</variable>
	<value-of select="svc:method-signature(.,$method-name,$request,$response,false())" />
</for-each>

<text />

}
<text />

</result-document>
</template>

</stylesheet>
