<?xml version="1.0" encoding="UTF-8"?>
<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:seaf="http://seaf.sf.net/seaf"
	xmlns:per="http://seaf.sf.net/seaf-persistence"
	xmlns:svc="http://seaf.sf.net/seaf-service"
	version="2.0">
<import href="functions/SeafServiceBusinessFunctions.xsl" />
<output method="text" />

<param name="service-merged-file-name" />
<variable name="merged-service-file" select="document($service-merged-file-name)" />
<variable name="objects" select="$merged-service-file//svc:service-layer//svc:object" />

<template match="//svc:service-layer/svc:service">
	<variable name="interface-full-type" select="svc:service-interface-full-type(.)" />
	<variable name="interface-class" select="seaf:type-class($interface-full-type)" />
	<variable name="interface-dir" select="seaf:type-dir($interface-full-type)" />
	<variable name="interface-package" select="seaf:type-package($interface-full-type)" />
	<variable name="class-name" select="concat($interface-class,'Factory')" />

<result-document href="{$interface-dir}/{$class-name}.java">

<text />/**
 * GENERATED BY Seaf Persistence Generator. DO NOT EDIT.
 */
package <value-of select="$interface-package" />;

import java.util.HashMap;

import net.sf.seaf.factory.Factory;
import net.sf.seaf.service.ServiceFactoryBase;
import net.sf.sit.SITConfigurer;
<for-each select="svc:controller">
	<variable name="entity-name" select="@entity" />
	<variable name="controller-full-type"
		select="svc:controller-interface-full-type(.,..)" />
import <value-of select="$controller-full-type" />;<text />
</for-each>

/**
 * Plain-Java factory of <value-of select="$interface-class" />.
 */
public class <value-of select="$class-name" /> extends ServiceFactoryBase {

	/**
	 * Default constructor.
	 */
	public <value-of select="$class-name" />() {
	}

	/**
	 * Full constructor.
	 * 
	 * @param persistenceFactory
	 *            Server controllers' factory
	 */
	public <value-of select="$class-name" />(Factory persistenceFactory) {
		super(persistenceFactory);
	}

	/**
	 * Create and return the instance of the service facade interface
	 * implementation.
	 * &lt;p>
	 * The implementation is a Java dynamic proxy created using SIT.
	 * 
	 * @return Service instance
	 */
	public <value-of select="$interface-class" /> getInstance() {
		@SuppressWarnings("unchecked")
		SITConfigurer sc = createSITConfigurer(<text />
			<value-of select="$interface-class" />.class<text />
	<for-each select="svc:controller">
		<variable name="entity-name" select="@entity" />
		<variable name="controller-full-type"
			select="svc:controller-interface-full-type(.,..)" />
		<text />,
			<text />
			<value-of select="seaf:type-class($controller-full-type)" />
			<text />.class<text />
	</for-each>
	<text />);
		return (<value-of select="$interface-class" />) sc.getFacade();
	}

	@Override
	protected void setMethodOverrides(HashMap&lt;String, String> overrides) {<text />
	<for-each select="svc:controller/svc:operation[@method]">
		<variable name="entity-name" select="../@entity" />
		<variable name="controller-full-type"
			select="svc:controller-interface-full-type(..,../..)" />
		overrides.put("<value-of select="@name" />",
			<value-of select="seaf:type-class($controller-full-type)" />
				<text />.class.getName() + ".<value-of select="@method" />");<text />
	</for-each>
	}

}
<text />

</result-document>

<if test="not(@factory-type='java-only')">
	<variable name="spring-class-name" select="concat($interface-class,'SpringFactory')" />
<result-document href="{$interface-dir}/{$spring-class-name}.java">

<text />package <value-of select="$interface-package" />;

import net.sf.seaf.factory.impl.SpringFactory;

import org.springframework.beans.BeansException;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.BeanFactoryAware;
import org.springframework.beans.factory.ListableBeanFactory;

/**
 * Spring factory of <value-of select="$interface-class" />.
 * &lt;p>
 * Populates the persistenceFactory (used to instantiate the server controllers)
 * automatically by the {@link ListableBeanFactory} in which it is running. This
 * assumes the server controllers are defined in the same Spring context as the
 * service.
 * &lt;p>
 * Typical usage in Spring XML configuration:
 * 
 * &lt;pre>
 * &amp;lt;bean id="myServiceFactory" class="some.module.pkg.service.MyServiceSpringFactory" />
 * &amp;lt;bean id="myService" factory-bean="myServiceFactory" factory-method="getInstance" />
 * &lt;/pre>
 */
public class <value-of select="$spring-class-name" /> extends <text />
	<value-of select="$class-name" />
		implements BeanFactoryAware {

	/**
	 * Default constructor.
	 */
	public <value-of select="$spring-class-name" />() {
	}

	public void setBeanFactory(BeanFactory beanFactory) throws BeansException {
		if (!(beanFactory instanceof ListableBeanFactory)) {
			throw new IllegalArgumentException(
					"ListableBeanFactory is required. Consider using ApplicationContext "
							+ "instead of plain BeanFactory.");
		}
		ListableBeanFactory listableBeanFactory = (ListableBeanFactory) beanFactory;
		setPersistenceFactory(new SpringFactory(listableBeanFactory));
	}

}
</result-document>
</if>

</template>

</stylesheet>
