package net.sf.seaf.service.dozer;

import net.sf.seaf.factory.Factory;
import net.sf.seaf.factory.impl.DefaultInstantiatingFactory;
import net.sf.seaf.persistence.CodeTable;

import org.dozer.CustomConverter;

/**
 * Dozer custom converter that converts between String and code table.
 */
public class StringToCodeTableConverter implements CustomConverter {

	@SuppressWarnings({ "unchecked", "rawtypes" })
	public Object convert(Object existingDestinationFieldValue,
			Object sourceFieldValue, Class destinationClass, Class sourceClass) {
		if (null == sourceFieldValue)
			return null;
		if (String.class.isAssignableFrom(sourceClass)
				&& CodeTable.class.isAssignableFrom(destinationClass)) {
			CodeTable codeTable = (CodeTable) codeTableFactory
					.getInstanceOf(destinationClass);
			codeTable.setCode((String) sourceFieldValue);
			return codeTable;
		}
		if (CodeTable.class.isAssignableFrom(sourceClass)
				&& String.class.isAssignableFrom(destinationClass)) {
			return ((CodeTable) sourceFieldValue).getCode();
		}
		return null;
	}

	private Factory codeTableFactory = new DefaultInstantiatingFactory();

	public void setCodeTableFactory(Factory codeTableFactory) {
		this.codeTableFactory = codeTableFactory;
	}

}
